diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.cc ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.cc
--- ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.cc	2025-06-01 20:34:45.612702100 -0700
@@ -739,33 +957,33 @@
     // case, do nothing because the main PHY will start a TXOP and at the end of such TXOP
     // links will be unblocked and the channel access requested on all links
 
-    Time delay{};
+    std::optional<Time> delay;
 
     if (m_ccaLastPifs.IsPending() || m_switchMainPhyBackEvent.IsPending())
     {
         delay = std::max(Simulator::GetDelayLeft(m_ccaLastPifs),
                          Simulator::GetDelayLeft(m_switchMainPhyBackEvent));
     }
-    else if (mainPhy->IsStateSwitching() || mainPhy->IsStateCcaBusy() || mainPhy->IsStateRx())
+    else if (mainPhy->GetState()->GetLastTime(
+                 {WifiPhyState::SWITCHING, WifiPhyState::CCA_BUSY, WifiPhyState::RX}) ==
+             Simulator::Now())
     {
         delay = mainPhy->GetDelayUntilIdle();
-        NS_ASSERT(delay.IsStrictlyPositive());
     }
 
     NS_LOG_DEBUG("Main PHY state is " << mainPhy->GetState()->GetState());
+    auto edca = GetStaMac()->GetQosTxop(aci);
+    edca->NotifyChannelReleased(linkId); // to set access to NOT_REQUESTED
 
-    if (delay.IsZero())
+    if (!delay.has_value())
     {
         NS_LOG_DEBUG("Do nothing");
         return;
     }
 
-    auto edca = GetStaMac()->GetQosTxop(aci);
-    edca->NotifyChannelReleased(linkId); // to set access to NOT_REQUESTED
-
     NS_LOG_DEBUG("Schedule channel access request on link "
-                 << +linkId << " at time " << (Simulator::Now() + delay).As(Time::NS));
-    Simulator::Schedule(delay, [=]() {
+                 << +linkId << " at time " << (Simulator::Now() + *delay).As(Time::NS));
+    Simulator::Schedule(*delay, [=]() {
         edca->StartAccessAfterEvent(linkId,
                                     Txop::DIDNT_HAVE_FRAMES_TO_TRANSMIT,
                                     Txop::CHECK_MEDIUM_BUSY);
@@ -834,57 +1052,59 @@
     // use aux PHY CCA (if allowed) if the backoff has already counted down to zero on the aux PHY
     // link when the main PHY completes the switch
     const auto edca = GetStaMac()->GetQosTxop(aci);
-    const auto cam = GetStaMac()->GetChannelAccessManager(linkId);
     const auto auxPhy = GetStaMac()->GetWifiPhy(linkId);
     const auto switchDelay = mainPhy->GetChannelSwitchDelay();
-    const auto now = Simulator::Now();
     const auto auxPhyCcaCanBeUsed =
         m_useAuxPhyCca || (GetChannelForAuxPhy(linkId).GetTotalWidth() >=
                            GetChannelForMainPhy(linkId).GetTotalWidth());
-    const auto backoffEndBeforeSwitch = (cam->GetBackoffEndFor(edca) - now) <= switchDelay;
-
-    if (auxPhyCcaCanBeUsed && backoffEndBeforeSwitch)
-    {
-        NS_LOG_DEBUG("Schedule CCA check at the end of main PHY switch");
-        m_ccaLastPifs = Simulator::Schedule(switchDelay, [=, this]() {
-            // check NAV and CCA only if the backoff actually counted down to zero already
-            if (cam->GetBackoffEndFor(edca) <= Simulator::Now())
-            {
-                CheckNavAndCcaLastPifs(auxPhy, linkId, edca);
-            }
-        });
-    }
-
-    Time remNav{0};
-    if (const auto mainPhyLinkId = GetStaMac()->GetLinkForPhy(mainPhy))
-    {
-        auto mainPhyNavEnd = GetStaMac()->GetChannelAccessManager(*mainPhyLinkId)->GetNavEnd();
-        remNav = Max(remNav, mainPhyNavEnd - now);
-    }
-
-    SwitchMainPhy(linkId,
-                  false,
-                  RESET_BACKOFF,
-                  DONT_REQUEST_ACCESS,
-                  EmlsrUlTxopAuxPhyNotTxCapableTrace(aci, delay, remNav));
 
     // check expected channel access delay when switch is completed
     Simulator::Schedule(switchDelay, [=, this]() {
-        const auto accessDelay = cam->GetBackoffEndFor(edca) - Simulator::Now();
+        // this is scheduled before starting the main PHY switch, hence it is executed before the
+        // main PHY is connected to the aux PHY link
 
-        if (auxPhyCcaCanBeUsed && backoffEndBeforeSwitch && accessDelay.IsNegative())
+        if (!m_switchAuxPhy && !m_switchMainPhyBackEvent.IsPending())
         {
-            // backoff already counted down to zero and we used aux PHY CCA
+            // if SwitchAuxPhy is false and the switch main PHY back timer is not running, it means
+            // that the channel switch was interrupted, hence there is nothing to check
             return;
         }
 
+        const auto backoffEnd =
+            GetStaMac()->GetChannelAccessManager(linkId)->GetBackoffEndFor(edca);
         const auto pifs = GetStaMac()->GetWifiPhy(linkId)->GetPifs();
+        const auto now = Simulator::Now();
 
-        // if the remaining backoff time is shorter than PIFS when the main PHY completes the
-        // switch, we need to schedule a CCA check a PIFS after the end of the main PHY switch
-        if (accessDelay <= pifs)
+        // In case aux PHY CCA can be used and the backoff has not yet reached zero, no NAV and CCA
+        // check is needed. The channel width that will be used is the width of the aux PHY if less
+        // than a PIFS remains until the backoff reaches zero, and the width of the main PHY,
+        // otherwise. If aux PHY CCA can be used and the backoff has already reached zero, a NAV and
+        // CCA check is needed.
+
+        if (auxPhyCcaCanBeUsed && backoffEnd < now)
         {
-            // use main PHY CCA in the last PIFS interval after main PHY switch end
+            /**
+             * use aux PHY CCA in the last PIFS interval before main PHY switch end
+             *
+             *        Backoff    Switch
+             *          end     end (now)
+             * ──────────┴─────────┴──────────
+             *      |---- PIFS ----|
+             */
+            CheckNavAndCcaLastPifs(auxPhy, linkId, edca);
+        }
+        else if (!auxPhyCcaCanBeUsed && (backoffEnd - now <= pifs))
+        {
+            /**
+             * the remaining backoff time (if any) when the main PHY completes the switch is shorter
+             * than or equal to a PIFS, thus the main PHY performs CCA in the last PIFS interval
+             * after switch end
+             *
+             *        Switch    Backoff                 Backoff    Switch
+             *       end (now)    end                     end     end (now)
+             * ──────────┴─────────┴──────────   ──────────┴─────────┴──────────
+             *           |---- PIFS ----|                            |---- PIFS ----|
+             */
             NS_LOG_DEBUG("Schedule CCA check a PIFS after the end of main PHY switch");
             m_ccaLastPifs = Simulator::Schedule(pifs,
                                                 &AdvancedEmlsrManager::CheckNavAndCcaLastPifs,
@@ -893,27 +1113,45 @@
                                                 linkId,
                                                 edca);
         }
-        else if (!GetExpectedAccessWithinDelay(linkId,
-                                               accessDelay + m_switchMainPhyBackDelay +
-                                                   mainPhy->GetChannelSwitchDelay()))
+        else if (WifiExpectedAccessReason reason;
+                 !m_switchAuxPhy &&
+                 (reason = GetStaMac()->GetChannelAccessManager(linkId)->GetExpectedAccessWithin(
+                      Simulator::GetDelayLeft(m_switchMainPhyBackEvent) +
+                      mainPhy->GetChannelSwitchDelay())) !=
+                     WifiExpectedAccessReason::ACCESS_EXPECTED)
         {
             NS_LOG_DEBUG("No AC is expected to get backoff soon, switch main PHY back");
-            SwitchMainPhyBackDelayExpired(linkId);
-        }
-        else
-        {
-            // the main PHY must stay for some time on this link to check if it gets channel
-            // access. The timer is stopped if a DL or UL TXOP is started. When the timer
-            // expires, the main PHY switches back to the preferred link if SwitchAuxPhy is
-            // false
-            m_switchMainPhyBackEvent.Cancel();
-            m_switchMainPhyBackEvent =
-                Simulator::Schedule(accessDelay + m_switchMainPhyBackDelay,
-                                    &AdvancedEmlsrManager::SwitchMainPhyBackDelayExpired,
-                                    this,
-                                    linkId);
+            SwitchMainPhyBackDelayExpired(linkId, reason);
         }
     });
+
+    Time remNav{0};
+    if (const auto mainPhyLinkId = GetStaMac()->GetLinkForPhy(mainPhy))
+    {
+        auto mainPhyNavEnd = GetStaMac()->GetChannelAccessManager(*mainPhyLinkId)->GetNavEnd();
+        remNav = Max(remNav, mainPhyNavEnd - Simulator::Now());
+    }
+
+    SwitchMainPhy(linkId,
+                  false,
+                  DONT_REQUEST_ACCESS,
+                  EmlsrUlTxopAuxPhyNotTxCapableTrace(aci, delay, remNav));
+
+    // if SwitchAuxPhy is false, the main PHY must stay for some time on this link to check if it
+    // gets channel access. The timer is stopped if a DL or UL TXOP is started. When the timer
+    // expires, the main PHY switches back to the preferred link
+    if (!m_switchAuxPhy)
+    {
+        m_switchMainPhyBackEvent.Cancel();
+        m_switchMainPhyBackEvent =
+            Simulator::Schedule(switchDelay + m_switchMainPhyBackDelay,
+                                &AdvancedEmlsrManager::SwitchMainPhyBackDelayExpired,
+                                this,
+                                linkId,
+                                std::nullopt);
+        // start checking PHY activity on the link the main PHY is switching to
+        RegisterListener(auxPhy);
+    }
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.h ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/advanced-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/advanced-emlsr-manager.h	2025-06-01 20:34:45.613702300 -0700
@@ -11,8 +11,12 @@
 
 #include "default-emlsr-manager.h"
 
+#include "ns3/channel-access-manager.h"
+
 #include <memory>
 
+class EmlsrSwitchMainPhyBackTest;
+
 namespace ns3
 {
 
@@ -25,6 +29,9 @@
  */
 class AdvancedEmlsrManager : public DefaultEmlsrManager
 {
+    /// Allow test cases to access private members
+    friend class ::EmlsrSwitchMainPhyBackTest;
+
   public:
     /**
      * @brief Get the type ID.
@@ -35,6 +42,8 @@
     AdvancedEmlsrManager();
     ~AdvancedEmlsrManager() override;
 
+    std::optional<WifiIcfDrop> CheckMainPhyTakesOverDlTxop(uint8_t linkId) const override;
+
     /**
      * This method is called by the PHY listener attached to the main PHY when a switch main PHY
      * back timer is started to notify of events that may delay the channel access for the main
@@ -50,6 +59,8 @@
     std::pair<bool, Time> GetDelayUnlessMainPhyTakesOverUlTxop(uint8_t linkId) override;
     void SwitchMainPhyIfTxopGainedByAuxPhy(uint8_t linkId, AcIndex aci) override;
     void NotifyEmlsrModeChanged() override;
+    void SwitchMainPhyBackToPreferredLink(uint8_t linkId,
+                                          EmlsrMainPhySwitchTrace&& traceInfo) override;
 
     /**
      * Possibly take actions when notified of the MAC header of the MPDU being received by the
@@ -103,18 +114,33 @@
     void SwitchMainPhyIfTxopToBeGainedByAuxPhy(uint8_t linkId, AcIndex aci, const Time& delay);
 
     /**
-     * This method is called when the switch main PHY back delay timer (which is started when the
-     * main PHY switches to the link of an aux PHY that does not switch and is not TX capable)
-     * expires and decides whether to delay the request to switch the main PHY back to the preferred
-     * link or to execute it immediately.
+     * This method is called when the switch main PHY back timer (which is started when the main PHY
+     * switches to the link of an aux PHY that does not switch and is not TX capable) expires and
+     * decides whether to delay the request to switch the main PHY back to the preferred link or to
+     * execute it immediately. This method can also be called to terminate a running switch main PHY
+     * back timer, in case it is determined that channel access is not expected to be gained before
+     * the expiration of the timer plus the channel switch delay.
      *
      * @param linkId the ID of the link that the main PHY is leaving
+     * @param stopReason the reason for terminating the switch main PHY back timer before expiration
+     */
+    void SwitchMainPhyBackDelayExpired(uint8_t linkId,
+                                       std::optional<WifiExpectedAccessReason> stopReason);
+
+    /**
+     * Register a PHY listener so that this EMLSR Manager is notified of PHY events generated by
+     * the given PHY.
+     *
+     * @param phy the PHY which a listener is connected to
      */
-    void SwitchMainPhyBackDelayExpired(uint8_t linkId);
+    void RegisterListener(Ptr<WifiPhy> phy);
+
+    /// Disconnect the PHY listener from the PHY it is connected to (if any)
+    void UnregisterListener();
 
   private:
-    void DoNotifyTxopEnd(uint8_t linkId) override;
-    void DoNotifyIcfReceived(uint8_t linkId) override;
+    void DoNotifyTxopEnd(uint8_t linkId, Ptr<QosTxop> edca) override;
+    void DoNotifyDlTxopStart(uint8_t linkId) override;
     void DoNotifyUlTxopStart(uint8_t linkId) override;
 
     bool m_allowUlTxopInRx;        //!< whether a (main or aux) PHY is allowed to start an UL
@@ -128,15 +154,31 @@
     Time m_switchMainPhyBackDelay; //!< duration of the timer started in case of non-TX capable aux
                                    //!< PHY when medium is sensed busy during the PIFS interval
                                    //!< preceding/following the main PHY switch end
-    EventId m_ccaLastPifs;         //!< event scheduled in case of non-TX capable aux PHY to
-                                   //!< determine whether TX can be started based on whether
-                                   //!< the medium has been idle during the last PIFS interval
+    bool m_keepMainPhyAfterDlTxop; //!< whether the main PHY must stay, for a switch main PHY back
+                                   //!< delay, on an aux PHY link after a DL TXOP, in case aux PHYs
+                                   //!< are not TX capable and do not switch
+    bool m_checkAccessOnMainPhyLink; //!< in case aux PHYs are not TX capable and an Access
+                                     //!< Category, say it AC X, is about to gain channel access on
+                                     //!< an aux PHY link, determine whether the time the ACs with
+                                     //!< priority higher than or equal to AC X and with frames to
+                                     //!< send on the main PHY link are expected to gain access on
+                                     //!< the main PHY link should be taken into account when taking
+                                     //!< the decision to switch the main PHY to the aux PHY link
+    AcIndex m_minAcToSkipCheckAccess; //!< if m_checkAccessOnMainPhyLink is set to false, indicate
+                                      //!< the minimum priority AC for which it is allowed to skip
+                                      //!< the check related to the expected channel access time on
+                                      //!< the main PHY link
+    EventId m_ccaLastPifs;            //!< event scheduled in case of non-TX capable aux PHY to
+                                      //!< determine whether TX can be started based on whether
+                                      //!< the medium has been idle during the last PIFS interval
     EventId m_switchMainPhyBackEvent; //!< event scheduled in case of non-TX capable aux PHY when
                                       //!< medium is sensed busy during the PIFS interval
                                       //!< preceding/following the main PHY switch end
     std::shared_ptr<WifiPhyListener>
-        m_phyListener; //!< PHY listener connected to the main PHY while operating on the link of
-                       //!< an aux PHY that is not TX capable
+        m_phyListener; //!< PHY listener connected to an aux PHY (that is not TX capable and does
+                       //!< not switch link) while the main PHY attempts to gain access on the aux
+                       //!< PHY link
+    Ptr<WifiPhy> m_auxPhyWithListener; //!< aux PHY which a PHY listener is connected to
 };
 
 /**
@@ -147,16 +189,26 @@
 {
     static constexpr std::string_view m_name = "TxopNotGainedOnAuxPhyLink"; //!< trace name
 
-    bool nothingToTx; //!< if true, the main PHY managed to gain a TXOP but had nothing to transmit
+    Time elapsed; //!< the time elapsed since the switch main PHY back timer started
+    std::optional<WifiExpectedAccessReason>
+        earlySwitchReason; //!< the reason why the main PHY switches back before the expiration of
+                           //!< the switch main PHY back timer
+    bool isSwitching; //!< whether the main PHY is switching while it is requested to switch back
 
     /**
      * Constructor provided because this struct is not an aggregate (it has a base struct), hence
      * we cannot use designated initializers.
      *
-     * @param nothing the value for the nothingToTx field
-     */
-    EmlsrSwitchMainPhyBackTrace(bool nothing)
-        : nothingToTx(nothing)
+     * @param time the value for the elapsed field
+     * @param reason the value for the earlySwitchReason field
+     * @param switching the value for the isSwitching field
+     */
+    EmlsrSwitchMainPhyBackTrace(Time time,
+                                std::optional<WifiExpectedAccessReason> reason,
+                                bool switching)
+        : elapsed(time),
+          earlySwitchReason(reason),
+          isSwitching(switching)
     {
     }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/ap-emlsr-manager.h ns-3.45/src/wifi/model/eht/ap-emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/ap-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/ap-emlsr-manager.h	2025-06-01 20:34:45.613702300 -0700
@@ -79,7 +79,14 @@
      *         all the clients solicited by the MU-RTS are EMLSR clients that have sent (or
      *         are sending) a frame to the AP
      */
-    virtual bool UpdateCwAfterFailedIcf() = 0;
+    virtual bool UpdateCwAfterFailedIcf() const = 0;
+
+    /**
+     * @return whether the AP MLD shall report an ICF failure to the remote station manager when
+     *         all the clients solicited by the MU-RTS are EMLSR clients that have sent (or are
+     *         sending) a frame to the AP
+     */
+    virtual bool ReportFailedIcf() const = 0;
 
   protected:
     void DoDispose() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.cc ns-3.45/src/wifi/model/eht/default-ap-emlsr-manager.cc
--- ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/default-ap-emlsr-manager.cc	2025-06-01 20:34:45.613702300 -0700
@@ -50,7 +50,13 @@
 }
 
 bool
-DefaultApEmlsrManager::UpdateCwAfterFailedIcf()
+DefaultApEmlsrManager::UpdateCwAfterFailedIcf() const
+{
+    return true;
+}
+
+bool
+DefaultApEmlsrManager::ReportFailedIcf() const
 {
     return true;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.h ns-3.45/src/wifi/model/eht/default-ap-emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/default-ap-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/default-ap-emlsr-manager.h	2025-06-01 20:34:45.613702300 -0700
@@ -34,7 +34,8 @@
     Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
                                      const WifiTxVector& txVector,
                                      WifiPhyBand band) override;
-    bool UpdateCwAfterFailedIcf() override;
+    bool UpdateCwAfterFailedIcf() const override;
+    bool ReportFailedIcf() const override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/default-emlsr-manager.cc ns-3.45/src/wifi/model/eht/default-emlsr-manager.cc
--- ns-3.44/src/wifi/model/eht/default-emlsr-manager.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/default-emlsr-manager.cc	2025-06-01 20:34:45.613702300 -0700
@@ -124,7 +124,6 @@
 
         // the Aux PHY is not actually switching (hence no switching delay)
         GetStaMac()->NotifySwitchingEmlsrLink(m_auxPhyToReconnect, *currLinkId, Seconds(0));
-        SetCcaEdThresholdOnLinkSwitch(m_auxPhyToReconnect, *currLinkId);
     }
 
     // if currLinkId has no value, it means that the main PHY switch is interrupted, hence reset
@@ -189,11 +188,20 @@
 DefaultEmlsrManager::DoGetDelayUntilAccessRequest(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << linkId);
+    auto phy = GetStaMac()->GetWifiPhy(linkId);
+    auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+
+    if (phy == mainPhy)
+    {
+        // UL TXOP is going to start
+        m_rtsStartingUlTxop[linkId] = {Simulator::Now(), false};
+    }
+
     return {true, Time{0}}; // start the TXOP
 }
 
 void
-DefaultEmlsrManager::DoNotifyIcfReceived(uint8_t linkId)
+DefaultEmlsrManager::DoNotifyDlTxopStart(uint8_t linkId)
 {
     NS_LOG_FUNCTION(this << linkId);
 }
@@ -205,17 +213,28 @@
 }
 
 void
-DefaultEmlsrManager::DoNotifyTxopEnd(uint8_t linkId)
+DefaultEmlsrManager::DoNotifyTxopEnd(uint8_t linkId, Ptr<QosTxop> edca)
 {
-    NS_LOG_FUNCTION(this << linkId);
+    NS_LOG_FUNCTION(this << linkId << edca);
+
+    if (m_switchAuxPhy)
+    {
+        return; // nothing to do
+    }
 
     // switch main PHY to the previous link, if needed
-    if (!m_switchAuxPhy)
+    if (const auto it = m_rtsStartingUlTxop.find(linkId);
+        it != m_rtsStartingUlTxop.cend() && it->second.second)
     {
+        // TXOP ended due to a CTS timeout following the RTS that started a TXOP
         const auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
         const auto delay = mainPhy->IsStateSwitching() ? mainPhy->GetDelayUntilIdle() : Time{0};
-        SwitchMainPhyBackToPreferredLink(linkId, EmlsrTxopEndedTrace(delay));
+        SwitchMainPhyBackToPreferredLink(linkId, EmlsrCtsAfterRtsTimeoutTrace(delay));
+        m_rtsStartingUlTxop.erase(it);
+        return;
     }
+
+    SwitchMainPhyBackToPreferredLink(linkId, EmlsrTxopEndedTrace());
 }
 
 void
@@ -244,7 +263,6 @@
     {
         SwitchMainPhy(GetMainPhyId(),
                       false,
-                      DONT_RESET_BACKOFF,
                       REQUEST_ACCESS,
                       std::forward<EmlsrMainPhySwitchTrace>(traceInfo));
     }
@@ -256,11 +274,7 @@
             // require the main PHY to switch link)
             if (!GetEhtFem(linkId)->UsingOtherEmlsrLink())
             {
-                SwitchMainPhy(GetMainPhyId(),
-                              false,
-                              DONT_RESET_BACKOFF,
-                              REQUEST_ACCESS,
-                              std::move(*info));
+                SwitchMainPhy(GetMainPhyId(), false, REQUEST_ACCESS, std::move(*info));
             }
         });
     }
@@ -304,7 +318,7 @@
 
     // the main PHY shall terminate the channel switch at the end of CTS reception;
     // the time remaining to the end of CTS reception includes two propagation delays
-    return rtsTxTime + phy->GetSifs() + ctsTxTime + MicroSeconds(2 * MAX_PROPAGATION_DELAY_USEC);
+    return rtsTxTime + phy->GetSifs() + ctsTxTime + 2 * MAX_PROPAGATION_DELAY;
 }
 
 std::pair<bool, Time>
@@ -341,7 +355,7 @@
 
     // TXOP can be started, main PHY will be scheduled to switch by NotifyRtsSent as soon as the
     // transmission of the RTS is notified
-    m_switchMainPhyOnRtsTx[linkId] = Simulator::Now();
+    m_rtsStartingUlTxop[linkId] = {Simulator::Now(), false};
 
     return {true, Time{0}};
 }
@@ -353,30 +367,38 @@
 {
     NS_LOG_FUNCTION(this << *rts << txVector);
 
-    const auto it = m_switchMainPhyOnRtsTx.find(linkId);
+    const auto it = m_rtsStartingUlTxop.find(linkId);
 
-    if (it == m_switchMainPhyOnRtsTx.cend() || it->second != Simulator::Now())
+    if (it == m_rtsStartingUlTxop.cend() || it->second.first != Simulator::Now())
     {
-        // No request for main PHY to switch or obsolete request
-        return;
+        return; // Not an RTS starting an UL TXOP
     }
+    it->second.second = true;
 
-    // Main PHY shall terminate the channel switch at the end of CTS reception
+    auto phy = GetStaMac()->GetWifiPhy(linkId);
     auto mainPhy = GetStaMac()->GetDevice()->GetPhy(m_mainPhyId);
+
+    if (phy == mainPhy)
+    {
+        return; // RTS sent by the main PHY
+    }
+
+    // Main PHY shall terminate the channel switch at the end of CTS reception
     const auto delay = GetTimeToCtsEnd(linkId, txVector) - mainPhy->GetChannelSwitchDelay();
     NS_ASSERT_MSG(delay.IsPositive(),
                   "RTS is being sent, but not enough time for main PHY to switch");
 
     NS_LOG_DEBUG("Schedule main Phy switch in " << delay.As(Time::US));
     m_ulMainPhySwitch[linkId] = Simulator::Schedule(delay, [=, this]() {
-        SwitchMainPhy(linkId,
-                      false,
-                      RESET_BACKOFF,
-                      DONT_REQUEST_ACCESS,
-                      EmlsrUlTxopRtsSentByAuxPhyTrace{});
+        SwitchMainPhy(linkId, false, DONT_REQUEST_ACCESS, EmlsrUlTxopRtsSentByAuxPhyTrace{});
     });
+}
 
-    m_switchMainPhyOnRtsTx.erase(it);
+void
+DefaultEmlsrManager::DoNotifyProtectionCompleted(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+    m_rtsStartingUlTxop.erase(linkId);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/default-emlsr-manager.h ns-3.45/src/wifi/model/eht/default-emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/default-emlsr-manager.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/default-emlsr-manager.h	2025-06-01 20:34:45.613702300 -0700
@@ -73,7 +73,8 @@
      * @param traceInfo information to pass to the main PHY switch traced callback (the fromLinkId
      *                  and toLinkId fields are set by SwitchMainPhy)
      */
-    void SwitchMainPhyBackToPreferredLink(uint8_t linkId, EmlsrMainPhySwitchTrace&& traceInfo);
+    virtual void SwitchMainPhyBackToPreferredLink(uint8_t linkId,
+                                                  EmlsrMainPhySwitchTrace&& traceInfo);
 
     bool m_switchAuxPhy; /**< whether Aux PHY should switch channel to operate on the link on which
                               the Main PHY was operating before moving to the link of the Aux PHY */
@@ -81,9 +82,9 @@
                                       //!< the main PHY is operating has to connect a listener to
                                       //!< when the main PHY is back operating on its previous link
     EventId m_auxPhySwitchEvent;      //!< event scheduled for an aux PHY to switch link
-    std::map<uint8_t, Time> m_switchMainPhyOnRtsTx; //!< link ID-indexed map of the time when an RTS
-                                                    //!< that requires the main PHY to switch link
-                                                    //!< is expected to be transmitted on the link
+    std::map<uint8_t, std::pair<Time, bool>>
+        m_rtsStartingUlTxop; //!< link ID-indexed map indicating the time when an UL TXOP is going
+                             //!< to start and whether it is starting with an RTS
 
   private:
     /**
@@ -108,9 +109,10 @@
                              uint8_t nextLinkId,
                              Ptr<WifiPhy> auxPhy,
                              Time duration) override;
-    void DoNotifyIcfReceived(uint8_t linkId) override;
+    void DoNotifyDlTxopStart(uint8_t linkId) override;
     void DoNotifyUlTxopStart(uint8_t linkId) override;
-    void DoNotifyTxopEnd(uint8_t linkId) override;
+    void DoNotifyTxopEnd(uint8_t linkId, Ptr<QosTxop> edca) override;
+    void DoNotifyProtectionCompleted(uint8_t linkId) override;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-capabilities.cc ns-3.45/src/wifi/model/eht/eht-capabilities.cc
--- ns-3.44/src/wifi/model/eht/eht-capabilities.cc	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-capabilities.cc	2025-06-01 20:34:45.613702300 -0700
@@ -415,7 +415,7 @@
 void
 EhtCapabilities::Print(std::ostream& os) const
 {
-    os << "EHT Capabilities="; // TODO
+    os << "EHT Capabilities=[]"; // TODO
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/eht-capabilities.h ns-3.45/src/wifi/model/eht/eht-capabilities.h
--- ns-3.44/src/wifi/model/eht/eht-capabilities.h	2025-03-09 16:55:49.787372600 -0700
+++ ns-3.45/src/wifi/model/eht/eht-capabilities.h	2025-06-01 20:34:45.613702300 -0700
@@ -103,6 +103,7 @@
     uint8_t
         support20MhzOperatingStaReceivingNdpWithWiderBw : 1; //!< Support For 20 MHz Operating STA
                                                              //!< Receiving NDP With Wider Bandwidth
+
     uint8_t nonOfdmaUlMuMimoBwNotLargerThan80Mhz : 1; //!< Non-OFDMA UL MU-MIMO (BW ≤ 80 MHz)
     uint8_t nonOfdmaUlMuMimo160Mhz : 1;               //!< Non-OFDMA UL MU-MIMO (BW = 160 MHz)
     uint8_t nonOfdmaUlMuMimo320Mhz : 1;               //!< Non-OFDMA UL MU-MIMO (BW = 320 MHz)
@@ -176,11 +177,14 @@
      * Deserialize the Supported EHT-MCS And NSS Set subfield
      *
      * @param start iterator pointing to where the Supported EHT-MCS And NSS Set subfield should be
-     * read from \param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously
-     * serialized IEs \param heSupportedChannelWidthSet supported channel width set based on
-     * previously deserialized HE capabilities IE \param support320MhzIn6Ghz flag whether 320 MHz is
-     * supported in 6 GHz band based on EHT PHY capabilities subfield \return the number of bytes
-     * read
+     * read from
+     * @param is2_4Ghz indicating whether PHY is operating in 2.4 GHz based on previously serialized
+     * IEs
+     * @param heSupportedChannelWidthSet supported channel width set based on previously
+     * deserialized HE capabilities IE
+     * @param support320MhzIn6Ghz flag whether 320 MHz is supported in 6 GHz band based on EHT PHY
+     * capabilities subfield
+     * @return the number of bytes read
      */
     uint16_t Deserialize(Buffer::Iterator start,
                          bool is2_4Ghz,
